from Tkinter import *
from tkFileDialog import *
from InputFrame import *
from globalVars import gifdir, colors
from tkMessageBox import showwarning, showerror


class ChamRowDemo(Frame):
    def __init__(self, parent, color, colors, **args):
        Frame.__init__(self, parent, args)        
        self.color = color
        self.otherColors = colors[:]
        self.otherColors.remove(self.color)
        self.image = PhotoImage(file = gifdir + color + ".gif")
        self.initNumber = IntVar()
        self.initNumber.set(5)
        self.behaviour = []
        self.brain = []
        self.createObjects()
        
        # initial settings (custom, all colors and equal probability selected. Disable what must me disabled)
        self.bhvLB.select_set(2)
        self.colorLB.select_set(0,END)
        self.setState(self.colorFrame,'normal')
        self.radioVar.set('e')
        self.typeLB.select_set(0)
        self.setState(self.brwButton)
        self.setState(self.brEntry)
        self.setState(self.brLabel)


    def createObjects(self):
        behaviours = ['only to the rarest', 'only to the commonest', 'customize behaviour']
        chamTypes = ['Random Moving','Chaser','Runner']
        bigFont = ('Times',12,'normal')
        
        self.left = Frame(self, relief=RIDGE, bd = 1, padx=20)
        self.midl = Frame(self,relief=RIDGE, bd=1, padx=10)
        self.rite = Frame(self, relief=RIDGE, bd=1, padx=10, pady=10)
        
        self.left.pack(side=LEFT,padx=10, pady=10, expand=YES, fill=Y)
        Label(self.left, image = self.image, relief=RIDGE).grid(row=0,column=0,columnspan=2,pady=30)
        Label(self.left, text='Initial Number : ', width=12).grid(row=1,column=0)
        entry = Entry(self.left, textvariable = self.initNumber, width=5)
        entry.grid(row=1,column=1)
        
        self.midl.pack(side=LEFT, expand = YES, fill=Y, pady=10)
        Label(self.midl, font = bigFont,text='Change color : ').pack(side = LEFT)

        self.bhvLB = Listbox(self.midl, exportselection=0, height=3, width=20, selectmode=SINGLE)
        self.bhvLB.bind("<Button-1>", (lambda event,lb=self.bhvLB: self.bhvLBCommand(event.y,lb)))
        for bhv in behaviours:
            self.bhvLB.insert(END, bhv)
        self.bhvLB.pack(side=LEFT)


        self.colorFrame=Frame(self.midl, padx = 10, pady=10)
        self.colorFrame.pack(expand=YES, fill=Y, padx = 10, pady=5)
        colorFrame = Frame(self.colorFrame,padx=10,pady=5,relief=RIDGE,bd=1)
        colorFrame.pack(side=LEFT,expand=YES,fill=Y,pady=5,padx=5)
        Label(colorFrame, font = bigFont, text='select changing colors').grid(row=0,column=0,columnspan=3,pady=10)
        self.colorLB = Listbox(colorFrame, exportselection=0, height=4, width=8, selectmode=MULTIPLE)
        for color in self.otherColors:
            self.colorLB.insert(END, color)
        self.colorLB.grid(row=2,column=1,rowspan=3,padx=20)
        self.myColVar = StringVar()
        self.hitColVar = StringVar()
        self.hitIfColVar = StringVar()
        self.hitColVar = StringVar()
        self.myColVar.set('N')
        self.hitColVar.set('N')
        self.hitIfColVar.set('N')
        self.myColCb = Checkbutton(colorFrame, text = 'include my color',
                                   variable=self.myColVar, onvalue='Y',offvalue='N')
        self.hitColCb = Checkbutton(colorFrame, text = 'include hit color',
                                    variable=self.hitColVar, onvalue='Y',offvalue='N')
        self.hitIfColCb = Checkbutton(colorFrame, text = 'include hit color if in list',
                                    variable=self.hitIfColVar, onvalue='Y',offvalue='N')
        Label(colorFrame,text = 'LIST').grid(row=1,column=1,padx=20)
        self.myColCb.grid(row=1,column=0,sticky=W,)
        Label(colorFrame,text = '- - - - - - - - - - -').grid(row=2,column=0)
        self.hitColCb.grid(row=3,column=0,sticky=W)
        self.hitIfColCb.grid(row=4,column=0,sticky=W)
        
        self.hitColCb.bind("<Button-1>", (lambda event,cbVar=self.hitColVar,
                                          cbVar2=self.hitIfColVar: self.cbSwitch(event,cbVar,cbVar2)))
        self.hitIfColCb.bind("<Button-1>", (lambda event,cbVar=self.hitIfColVar,
                                            cbVar2=self.hitColVar: self.cbSwitch(event,cbVar,cbVar2,'Input Warning')))
        

        radioFrame = Frame(self.colorFrame,padx=10,pady=10,relief=RIDGE,bd=1)
        radioFrame.pack(side=RIGHT,expand=YES,fill=Y,padx=10,pady=5)
        self.radioVar = StringVar()
        Label(radioFrame, font = bigFont, text='changing probability').grid(row=0,column=0,pady=10)
        Radiobutton(radioFrame, text='change with equal probability', var=self.radioVar, value = 'e').grid(row=1,column=0, sticky=W)
        Radiobutton(radioFrame, text='prefer commoner colors', var=self.radioVar, value = 'c').grid(row=2,column=0,sticky=W)
        Radiobutton(radioFrame, text='prefer rarer colors',var=self.radioVar, value = 'r').grid(row=3,column=0,sticky=W)

        self.rite.pack(side=LEFT, expand = YES, fill=Y, padx=10, pady=10)
        typeFrame=Frame(self.rite)
        typeFrame.pack(side=LEFT)
        Label(typeFrame, font = bigFont,text = 'chameleon type').pack(side=TOP, pady=10)
        self.typeLB = Listbox(typeFrame, exportselection=0, height=3, width=15, selectmode=SINGLE)
        self.typeLB.bind("<Button-1>", (lambda event,lb=self.typeLB: self.typeLBCommand(event.y,lb)))
        for chamType in chamTypes:
            self.typeLB.insert(END, chamType)
        self.typeLB.pack(side=LEFT)

        fileFrame = Frame(self.rite)
        fileFrame.pack(side = RIGHT, padx=20)
        self.brLabel=Label(fileFrame,font = bigFont, text = 'brain file')
        self.brLabel.pack(side=TOP, pady=10)        
        self.brainPath = StringVar()
        self.brainPath.set('')
        self.brEntry = Entry(fileFrame, width=15, textvariable=self.brainPath)
        self.brEntry.xview(END)
        self.brEntry.pack(side=TOP)
        self.brwButton = Button(fileFrame, text = 'Browse',command=self.browse)
        self.brwButton.pack(side = TOP, expand=YES, fill=X)
        
        
    def setState(self, widget, state='disabled'):
        try:
            widget.configure(state=state)
        except TclError:
            pass
        for child in widget.winfo_children():
            self.setState(child, state=state)

    def check(self):
        try:
            number = int(self.initNumber.get())
            if (number >50) or (number<0):
                showerror('Input Error : %s chamaleon' % self.color,
                          'The initial number should be an INTEGER in [0,50]',parent = self)
                return 0            
        except ValueError:
            showerror('Input Error : %s chamaleon' % self.color,
                      'The initial number should be an INTEGER in [0,50]',parent = self)
            return 0
        if (len(self.colorLB.curselection()) == 0) and ((self.myColVar.get()=='N') and (self.hitColVar.get()=='N')) :
            showerror('Input Error : %s chamaleon' % self.color,
                      'Please select at least one CHANGING COLOR or select one of the CHECK BUTTONS',parent = self)
            return 0
        return 1



    def bhvLBCommand(self, y, lb):
        if lb.nearest(y)<2:
            self.setState(self.colorFrame)
            self.setState(self.myColCb,'normal')
            self.setState(self.hitColCb,'normal')

        else:
            self.setState(self.colorFrame,'normal')
            self.radioVar.set('e')

    def typeLBCommand(self, y, lb):
        if lb.nearest(y)==0:
            self.setState(self.brwButton)
            self.setState(self.brEntry)
            self.setState(self.brLabel)
        else:
            self.setState(self.brwButton,'normal')
            self.setState(self.brEntry,'normal')
            self.setState(self.brLabel,'normal')
            self.brEntry.delete(0,END)
            if lb.nearest(y)==1:
                self.brainPath.set('./brains/chaser_30k.cbr')
            else:
                self.brainPath.set('./brains/runner_30k.rbr')
            self.brEntry.xview(END)


    def browse(self):
        if self.typeLB.curselection()[0]=='1':
            self.brainPath.set(askopenfilename(filetypes=[("Chaser brain",".cbr")]))
        elif self.typeLB.curselection()[0]=='2':
            self.brainPath.set(askopenfilename(filetypes=[("Runner brain",".rbr")]))
        self.brEntry.xview(END)

    def getVars(self):
        #this assumes that the row check is ok
        variables = []
        variables.append(self.initNumber.get())
        bhv = self.bhvLB.curselection()[0]
        if bhv == '0':
            variables.append('r')
            variables.append('')
            variables.append('')
        elif bhv == '1':
            variables.append('c')
            variables.append('')
            variables.append('')
        else:
            variables.append('m')
            temp = []
            if len(self.colorLB.curselection())==0:
                if self.hitIfColVar.get()=='Y':
                    self.hitIfColVar.set('N')
                    showwarning('Input Warning','Color list empty,"include hit color if in list" has been forced to 0 ',parent=self)
            else :
                for index in self.colorLB.curselection():
                    temp.append(self.colorLB.get(index))
            variables.append(temp)
            variables.append(self.radioVar.get())
            

        variables.append(self.myColVar.get())
        variables.append(self.hitColVar.get())
        variables.append(self.hitIfColVar.get())

        bhv = self.typeLB.curselection()[0]
        if bhv == '0':
            variables.append('rm')
            variables.append('')
        elif bhv == '1':
            variables.append('c')
            variables.append(self.brainPath.get())
        else :
            variables.append('r')        
            variables.append(self.brainPath.get())

        print variables

        return variables[:]

    def cbSwitch(self,event,cbVar,cbVar2,warning=None):
        if cbVar.get() == 'N':
            cbVar2.set('N')
            if (warning != None) and (len(self.colorLB.curselection())==0):
                showwarning(warning,'The color list is empty!',parent=self)
            
        
    

        
            
            
        
                            
            
            
            
        


