"""
    Copyright 2006,2007 Riccardo Taormina (den3b@hotmail.com)
    
    This file is part of SmartChameleons.

    SmartChameleons is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    SmartChameleons is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with SmartChameleons; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

"""

#Class Chameleon

import random

class Chameleon:
    def __init__(self,number,color,graphItem,worldXSize=80,worldYSize=80):
        self.number = number
        self.color = color
        self.xPosition = random.randint(0,worldXSize-1)
        self.yPosition = random.randint(0,worldYSize-1)
        self.worldXSize = worldXSize
        self.worldYSize = worldYSize
        self.justChanged = False
        self.graphItem = graphItem

    def talk(self):
        #use this function to make the chemeleon show his position and colour
        print "[ ch",self.number,"] --- I'm in position X =",self.xPosition,\
              " , Y = ",self.yPosition, " and my color is ", self.color

    def move(self,changes = None):
        #changes are due intelligent moves. Otherwise a random move is performed
        if changes == None :
            self.xPosition += randomMove()
            self.yPosition += randomMove()
        else :
            self.xPosition += changes[0]
            self.yPosition += changes[1]
            
        #this because the world is wrapped up in himself like a toroid
        self.xPosition = (self.worldXSize + self.xPosition) % self.worldXSize
        self.yPosition = (self.worldYSize + self.yPosition) % self.worldYSize

                        


    def changeColor(self,newColor):
        self.color = newColor
        self.justChanged = True

    def hasntJustChanged(self):
        return not self.justChanged
                
def randomMove():
    return random.randint(-1,1)
