from Tkinter import *
from ChamRowDemo import *
from InputWindowDemo import *
from globalVars import colors


class InputWindow(InputWindowDemo):
    def __init__(self, parent, **args):
        InputWindowDemo.__init__(self,parent,**args)
        self.parent = parent
        self.parent.withdraw()
        self.grab_set()
        self.protocol("WM_DELETE_WINDOW", self.cancel)
        self.title("Input Dialog")
        self.parent.wait_window(self)
        

    def cancel(self):
        self.destroy()
        self.parent.destroy()

    def next(self):
        if self.check():
            self.parent.envVars = []
            for var in self.variables:
                self.parent.envVars.append(int(var.get()))
            self.destroy()            
            self.parent.createChamInputObjects()
            

class CmdRow(Frame):
    def __init__(self,parent,root, **args):
        Frame.__init__(self, parent, args)
        self.root = root
        #Button(self, text='<< Back', font =('Times', 10, 'bold'), width=10, height=1,command = self.back).pack(side = LEFT, padx=20)
        Button(self, text='Next >>', font =('Times', 10, 'bold'), width=10, height=1, command=self.next).pack(side = RIGHT, padx=20)

    def back(self):
        pass

    def next(self):
        self.root.chamVars = []
        flag = True
        for row in self.root.chamRows:
            if not row.check():
                flag = False
                break
        if flag:
            for row in self.root.chamRows:
                temp = row.getVars()[:]
                self.root.chamVars.append(temp)
            #showinfo('Good info','Check is ok!!!!',parent = self)
            self.destroy()
            self.root.close() #here we send the data to the Observer
            
            
        
            

class ChamRow(ChamRowDemo):
    def __init__(self, parent, color, colors, **args):
        ChamRowDemo.__init__(self, parent, color, colors,**args)

        
class ChamCanvas(Canvas):
    def __init__(self, parent, colors, **args):
        Canvas.__init__(self, parent, args)
        # create the command panel
        cmdFrame = Frame(self, relief=Ridge, bd=1)
        Button(cmdFrame, text = 'Next >>')




class InputGUI(Toplevel):
    def __init__(self, parent, **args):
        Toplevel.__init__(self, parent, args)
        self.parent = parent
        self.envVars = []
        self.chamVars = []
        self.chamRows = []
        
        self.envInputWindow = InputWindow(self)
        

    def createChamInputObjects(self):

        self.colors=colors[0:self.envVars[2]]
        
        self.chamInputWindow = Toplevel(self)
        self.chamInputWindow.protocol("WM_DELETE_WINDOW", self.cancel)
        self.chamInputWindow.focus_set()
        self.chamInputWindow.title('Breeds options')
        self.chamCanvas = Canvas(self.chamInputWindow)

        self.chamInputWindow.resizable(0,0)
        # Grid sizing behavior in window
        self.chamInputWindow.rowconfigure(0, weight=1)
        self.chamInputWindow.columnconfigure(0, weight=1)
        
        self.chamCanvas.grid(row=0,column=0,sticky="nsew")
        # my ScrollBars
        horSB = Scrollbar(self.chamInputWindow, orient=HORIZONTAL, command=self.chamCanvas.xview)
        horSB.grid(row=1, column=0, sticky='we')
        verSB = Scrollbar(self.chamInputWindow, orient=VERTICAL, command=self.chamCanvas.yview)
        verSB.grid(row=0, column=1, sticky='sn')
        self.chamCanvas.configure(xscrollcommand=horSB.set, yscrollcommand=verSB.set)

        # mainFrame
        self.canvasMainFrame = Frame(self.chamCanvas)
        self.chamCanvas.create_window(0, 0, window=self.canvasMainFrame, anchor=N+W)
        
        CmdRow(self.canvasMainFrame, self, relief = RIDGE, bd=1, padx = 10, pady=10).pack(side=TOP,expand=YES, fill=BOTH, padx = 5, pady=5)
        for color in self.colors:
            row = ChamRow(self.canvasMainFrame, color, self.colors, relief = RIDGE, bd=1)
            row.pack(expand=YES, fill=BOTH, padx = 5, pady=5)
            self.chamRows.append(row)

        self.canvasMainFrame.update_idletasks()
        self.chamCanvas.configure(scrollregion=(0, 0, self.canvasMainFrame.winfo_width(), self.canvasMainFrame.winfo_height()))
        self.chamCanvas.configure(width=self.canvasMainFrame.winfo_width(), height=self.canvasMainFrame.winfo_height())
        self.chamInputWindow.wait_window(self.chamInputWindow)

    def cancel(self):
        self.chamInputWindow.destroy()
        self.destroy()

    def close(self):
        # close this GUI and return data to the Observer
        envLabels = ['worldXsize','worldYsize','nBreeds','nCycles','seed']
        chamLabels = ['startNumber','chgBehav','chgColors','chgProb','myCol','hitCol','hitIfCol','type','brainPath']
        envDict = {}
        chamDictsList = []
        i = 0
        for entry in envLabels:
            envDict[entry] = self.envVars[i]
            i = i + 1

        for row in self.chamVars:
            i = 0
            chamDict = {}
            for entry in chamLabels:
                chamDict[entry] = row[i]
                i = i + 1
            chamDictsList.append(chamDict)
        chamDicts = {}
        
        i=0
        for color in self.colors:
            chamDicts[color] = chamDictsList[i]
            i = i + 1

        self.parent.envDict = envDict
        self.parent.chamDicts = chamDicts
        print chamDicts
        self.destroy()
