from Tkinter import *
from tkMessageBox import *

fields = ['world X size', 'world Y size', 'number of breeds', 'number of cycles','random seed']
defValues = [20,10,3,1000,12345]
bndValues = [[1,30],[1,20],[3,5],[1,100000],[1,100000]]


class InputWindowDemo(Toplevel):
    def __init__(self, parent):
        Toplevel.__init__(self, parent)
        self.parent = parent
        self.variables = []
        # create the objects
        self.createObjects()

        
    def createObjects(self):
        left = Frame(self, relief = RIDGE, bd=1, padx = 5, pady=5)
        rite = Frame(self, relief = RIDGE, bd=1, padx = 5, pady=5)
        down = Frame(self,relief = RIDGE, bd=1, padx = 5, pady=5)
        left.grid(row=0, column=0)
        rite.grid(row=0, column=1)
        down.grid(row=1, column=0, columnspan = 2, sticky=EW)
        
        index = 0
        for field in fields:
            label = Label(left, width = 15, text = field, relief=RIDGE)
            label.pack()
            var = StringVar()
            entry = Entry(rite, width = 10, relief=SUNKEN, textvariable = var)
            var.set(str(defValues[index]))
            entry.pack()
            self.variables.append(var)
            index = index + 1
        Button(down, text = 'Quickstart', command = self.quickstart, width=10).pack(side=LEFT, fill=Y)
        Button(down, text = 'Clear',  command = self.clear, width=5).pack(side=LEFT, fill=Y)
        Button(down, text = 'Next >>', command = self.next, font = ('Times', 10, 'bold'), width=6).pack(side=RIGHT)


    def check(self):
        self.envVars = []
        index = 0
        try :
            for var in self.variables:
                min_ = bndValues[index][0]
                max_ = bndValues[index][1]
                temp = int(var.get())
                if (temp<min_) or (temp>max_):
                    errmsg = fields[index] + ' must be included in [%d,%d]' %(min_, max_)
                    showerror('Input Error', errmsg,parent = self)
                    break
                else :
                    self.envVars.append(var)
                    index = index + 1
        except ValueError :
            errmsg = fields[index] + ' must be and INTEGER within [%d,%d]' %(min_, max_)
            showerror('Input Error', errmsg,parent = self)
            return False
        if index == 5:
            #self.check = True
            #showinfo('Ok','Check is OK',parent = self)
            # here goes all the rest
            return True

    def next(self):
        self.check()
        

    def quickstart(self):
        index = 0
        for var in self.variables:
            var.set(str(defValues[index]))
            index = index + 1

    def clear(self):
        for var in self.variables :
            var.set('')
