"""
    Copyright 2006,2007 Riccardo Taormina (den3b@hotmail.com)
    
    This file is part of SmartChameleons.

    SmartChameleons is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    SmartChameleons is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with SmartChameleons; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

"""

from Tkinter import *
from tkFont import *

class OutputWindow(Toplevel):
    def __init__(self,parent):
        Toplevel.__init__(self,parent,bg='white')
        
        self.parent = parent
        self.title("Output")
        self.geometry("%dx%d%+d%+d" % (160, 160, 0, 0))
        self.resizable(False,False)

        self.protocol("WM_DELETE_WINDOW", self.handler)
        
        myFont = Font(family="Terminal", size=14)
        mySmallFont = Font(family="Terminal", size=10)

        r = 0
        for color in self.parent.colors:
            Label(self, font = myFont, bg= 'white',fg = color, text=color + ":").grid(row=r, column = 0)
            Label(self, font = myFont, bg= 'white',fg = color, textvariable = self.parent.breedNumbers[color]).grid(row=r,column=1)
            r = r + 1

        self.cycleFrame = Frame(self)
        self.cycleFrame.grid(row=r+1,sticky=N+S+W+E,pady=10)
        Label(self.cycleFrame, bg= 'white',font = mySmallFont, text="Cycle :").grid(row=0)
        Label(self.cycleFrame, bg= 'white',font = mySmallFont, justify = LEFT,  textvariable = self.parent.time).grid(row=0,column=1)


    def handler(self):
        self.parent.focus_set()
        self.withdraw()
