"""
    Copyright 2006,2007 Riccardo Taormina (den3b@hotmail.com)
    
    This file is part of SmartChameleons.

    SmartChameleons is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    SmartChameleons is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with SmartChameleons; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

"""

#GUI
from Tkinter import *
from tkFont import *
from thread import *
from tkMessageBox import showwarning

class Panel(Toplevel):
    def __init__(self,parent):
        Toplevel.__init__(self,parent)

        self.title("Control Panel")
        
        self.parent = parent


        self.protocol("WM_DELETE_WINDOW", self.quit)
        self.resizable(False,False)

        self.frame1=Frame(self)
        self.frame2=Frame(self.frame1,relief=RAISED,borderwidth=1)
        self.frame3=Frame(self.frame1,relief=RAISED,borderwidth=1)
        self.frame4=Frame(self.frame1,relief=RAISED,borderwidth=1)

        myFont = Font(family="Terminal", size=10, weight = BOLD)

        self.create_b = Button(self.frame1,font = myFont,text = "Create", width=20, command = self.create,height = 1)
        self.quit_b = Button(self.frame1,font = myFont, text = "Quit", width=10,command = self.quit,height = 1)
        self.go_b = Button(self.frame1,font = myFont,text = "Go", width=10,command = self.go, state = DISABLED,height = 1)
        self.out_b = Button(self.frame1,font = myFont,text = "Show output", width=20, command = self.output,state = NORMAL,height = 1)
        self.stop_b = Button(self.frame1,font = myFont,text = "Stop", width=10,command = self.stop,state = DISABLED,height = 1)
        self.step_b = Button(self.frame1,font = myFont,text = "Step", width=10,command = self.step,state = DISABLED,height = 1)
        self.envi_b = Button(self.frame1,font = myFont,text = "Show environment", width=20, command = self.showEnvi,state = NORMAL, height = 1)

        self.create_b.grid(row=0,column= 0,sticky = W+E+N+S)
        self.quit_b.grid(row=0,column=1,sticky = W+E+N+S)
        self.go_b.grid(row=0,column=2,sticky = W+E+N+S)
        self.out_b.grid(row=1,column= 0,sticky = W+E+N+S)
        self.stop_b.grid(row=1,column=1,sticky = W+E+N+S)
        self.step_b.grid(row=1,column=2,sticky = W+E+N+S)
        self.envi_b.grid(row=2,column = 0,sticky = W+E+N+S,columnspan=3)
        

        self.frame1.grid(row=0,column=0)
        self.frame2.grid(row=0,column=3,rowspan=3,sticky=N+S)
##        self.frame3.grid(row=2,column=1,columnspan=2,sticky=W+E+N+S)
##        self.frame4.grid(row=3,column=1,columnspan=2,sticky=W+E+N+S)


        self.speed = Scale(self.frame2,label = "Speed", command = self.getSpeed, state = DISABLED, from_=1, to = 10)
        self.speed.grid(row=0,column=0,sticky=N+S)
        self.frequency = Scale(self.frame2,label = "Refresh Frequency", command = self.getFrequency, state = DISABLED, from_=1, to = 10)
        self.frequency.grid(row=0,column=1,sticky=N+S)


    def create(self):
                
        self.go_b["state"]="normal"
        self.step_b["state"]="normal"
        self.stop_b["state"]="disabled"
        self.create_b["state"]="disabled"
        self.speed["state"]="normal"
        self.frequency["state"]="normal"

        self.parent.create()

    def quit(self):
        self.parent.quit()

    def stop(self):
        self.parent.stopIt = True
        self.step_b["state"]="normal"
        self.go_b["state"]="normal"

    def go(self):
        self.parent.stopIt = False
        self.go_b["state"]="disabled"
        self.step_b["state"]="disabled"
        self.stop_b["state"]="normal"
        self.parent.go()
        


    def step(self):
        showwarning('Step Warning', 'Sorry... not yet implemented!')
        #self.parent.step()

    def getSpeed(self,event):
        self.parent.speed = self.speed.get()

    def getFrequency(self,event):
        self.parent.refreshFrequency = self.frequency.get()

    def cancel(self):
        self.destroy()
        self.parent.destroy()

    def output(self):
        if self.parent.output.state() == "withdrawn": 
            self.parent.output.deiconify()
        else :
             self.parent.output.withdraw()

    def showEnvi(self):
        if self.parent.state()=="withdrawn":
            self.parent.visible = True
            self.parent.deiconify()            
        else :
            self.parent.visible = False
            self.parent.withdraw()

    
            
        


